            implicit none
            real*8 F1,F2,F3,F4
            integer N,nt,nfin,N0,j,ntsteps1,in_simu1_step1
            integer in_simu1_step2,in_simu1_step3,  k,m
            integer ntsteps2,in_simu2_step,ntsteps3,in_simu3_step
            integer ntsteps4,l
            real*8 alpha, beta, gama,Lambda,mu,dt,IFR
            real*8 beta2,time,beta1, beta3
            real*8 nu,AS,AE,AI,AR
            real*8 suma_s,suma_e
c-----
            real*8 epsi,sim_time1,xfin1,xin1
             real*8 sim_time2,sim_time3,sim_time4
             real*8 xfin2,xfin3,xin2,xin3,xin4,xfin4
            real*8 t1,t2,t3,t4,t5
            
            real*8 dE
            real*8 dS
            real*8 dI
            real*8 dR
            real*8 S(0:1000000), E(0:1000000), I(0:1000000)
            real*8 R(0:1000000)
            real*8 Sp(0:1000000), Ep(0:1000000), Ip(0:1000000)
            real*8 Rp(0:10000000)
            real*8 NN(0:10000000),NNp(0:1000000)
            
            real*8 S1(0:1000000), E1(0:1000000), I1(0:1000000)
            real*8 R1(0:1000000)
            real*8 Sp1(0:1000000), Ep1(0:1000000), Ip1(0:1000000)
            real*8 Rp1(0:1000000)
            real*8 NN1(0:1000000),NNp1(0:1000000)
            
           real*8 S2(0:1000000), E2(0:1000000), I2(0:1000000)
            real*8 R2(0:1000000)
            real*8 Sp2(0:1000000), Ep2(0:10000000), Ip2(0:1000000)
            real*8 Rp2(0:1000000)
            real*8 NN2(0:1000000),NNp2(0:1000000)           
            
            real*8 R0
            
            

            real*8 a(0:10000000), b(0:10000000)
            integer jmax,limit
            real*8 aux1,aux2
            real*8 b_0_1,a_0_1,a_1_1,b_j_m,a_j_m,a_m_m,a_0_m
            integer ifin1,ifin2,ifin3
            real*8 actual_time
            
            open(unit=1,file='susceptible.n')
            open(unit=2,file='exposed.n')
            open(unit=3,file='infected.n')
            open(unit=4,file='recovered.n')
            open(unit=10,file='p_susceptible.n')
            open(unit=20,file='p_exposed.n')
            open(unit=30,file='p_infected.n')
            open(unit=40,file='p_recovered.n')           
            
c write deaths and deaths per day in this file
            open(unit=7,file='dead_individuals.n')
            open(unit=9,file='dead_individuals_per_day.n')
            open(unit=50,file='NN.n')
          !   initial data
          
             write(6,*)'NN_dead_ind_N0-NN.n is dead individuals'
           dt = 0.01d0
c MOD: AHORA NO HACE FALTA PONER UN DIA MENOS 
            t1 = 0.d0
            t2 = 31.d0
            t3 = 70.d0
            t4 = 700.d0
            
            
        
        
c ----
            sim_time1 = t2
            sim_time2 = t3
            sim_time4 = t4
            
c ------
            in_simu1_step1 = t1/dt + 1
            xfin1 = t2/dt
            ifin1 = xfin1
            ntsteps1 = ifin1
        write(6,*)'in_simu1_step1, ntsteps1 ',in_simu1_step1,ntsteps1
             
            in_simu1_step2 = t2/dt + 1
            xfin2 = t3/dt
            ifin2 = xfin2
            ntsteps2 =  ifin2 - ifin1
        write(6,*)'in_simu1_step2, ntsteps2 ',in_simu1_step2,ntsteps2
            
             write(6,*)' ntsteps1+  ntsteps2 ', ntsteps1+  ntsteps2
             
            in_simu1_step3 = t3/dt + 1
            xfin3 = t4/dt
            ifin3= xfin3
            ntsteps3 =  ifin3 - ifin2
        write(6,*)'in_simu1_step3, ntsteps3 ',in_simu1_step3,ntsteps3


            
            write(6,*)'simulation time1 (days) ',sim_time1
            write(6,*)'in_simu1_step           ',in_simu1_step1
            write(6,*)' number of time steps 1 ', ntsteps1  
            write(6,*)'time step  (days)       ',dt
        
        
            N0 = 14839026.d0
            
            write(6,*)'N0 ',N0
            
            E(0) = 162.d0
            I(0) = 100.d0
            S(0) = N0 - E(0) - I(0)
            R(0) = 0.d0
            
            
c            I(0) = 0.001d0
c            E(0) = 0.d0
c            R(0) = 0.d0
c            S(0) = N0 - E(0) - I(0)
            
            
            write(6,*)'E(0) ',E(0)
            write(6,*)'S(0) ',S(0)
             write(6,*)'I(0) ',I(0)
             write(6,*)'R(0) ',R(0)
            
             NN(0) =  N0
             mu = 1.d0/76.d0/365.d0
        
             nu = 1.d0
             
             
             Lambda = mu* N0
             alpha = 0.00285d0 
        
            
             beta = 0.50478d0
             beta1 = beta
             beta2 = 0.14343d0
             beta3 = 0.234   !fit 21 mayo
        
    
             epsi = 11.06d0
             epsi = 11.064d0
             
             epsi = 1.d0/epsi
        
             gama= 6.740d0 
             gama= 1.d0/gama
             
             
             jmax = ntsteps1 - 1
             
             write(6,*)'number of memory terms (jmax) ', jmax
             
c --------       
            R0 = beta/(gama+ alpha)
            IFR = 100.d0*alpha/gama
            
      write(6,*)'parameters for time intervals t1, t2, t3 :', t1,t2,t3
            
            write(6,*)'*********************** '
            write(6,*)
            write(6,*)'nu                      ',nu 
            write(6,*)'jmax                    ',jmax
            write(6,*)'Lambda                  ',Lambda
            write(6,*)'mu                      ',mu
            write(6,*)'alpha                   ',alpha
            write(6,*)'beta1                   ',beta
            write(6,*)'beta2                   ',beta2
            write(6,*)'beta3                   ',beta3
            write(6,*)'epsi^{-1}               ',1/epsi
            write(6,*)'gama^{-1}              ',1/gama
            write(6,*)'R0 = beta1/(gama+alpha) ',R0
            write(6,*)'IFR                     ',IFR
            write(6,*)
            write(6,*)'*********************** '
             R0 = beta2/(gama+ alpha)
                write(6,*)'R02 = beta2/(gama+alpha) ',R0
             R0 = beta3/(gama+ alpha)
                write(6,*)'R03 = beta3/(gama+alpha) ',R0   
                

            write(6,*)'*****************************'
            write(6,*)'S(0) ',S(0)
            write(6,*)'E(0) ',E(0)
            write(6,*)'I(0) ',I(0)
            write(6,*)'R(0) ',R(0)
           
            write(6,*)'NN(0)   ',NN(0)
            
             write(6,*)'*****************************'
            
                in_simu1_step1 = 1 
               write(6,*)' ntsteps1',ntsteps1          

                  m=1
              
                time=m*dt
                
c                write(6,*)' time step m',m
                
                 b_0_1 = 1.d0/Gamma(nu+1.d0)
            
                 
      suma_s= S(0)+dt**nu*b_0_1*F1(S(0),E(0),I(0),R(0),NN(0),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)
      Sp(m)=suma_s   
       
      suma_s= E(0)+dt**nu*b_0_1*F2(S(0),E(0),I(0),R(0),NN(0),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)
      Ep(m)=suma_s
                  
      suma_s= I(0)+dt**nu*b_0_1*F3(S(0),E(0),I(0),R(0),NN(0),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)
              
      Ip(m)=suma_s
              
      suma_s= R(0)+dt**nu*b_0_1*F4(S(0),E(0),I(0),R(0),NN(0),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)
              
       Rp(m)=suma_s 
       
          NNp(m) = Sp(m) + Ep(m) + Ip(m) + Rp(m) 
          
              write(10,*)time,Sp(m)
              write(20,*)time,Ep(m)
              write(30,*)time,Ip(m)
              write(40,*)time,Rp(m)            
       
            a_0_1 = nu* dt**nu/gamma(nu+2.d0)
            a_1_1 = dt**nu/gamma(nu+2.d0)
        !write(6,*) 'a_0_1  a_1_1',a_0_1,  a_1_1 
        
      suma_e = S(0)+ a_0_1*F1(S(0),E(0),I(0),R(0),NN(0),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)
     1  + a_1_1* F1(Sp(m),Ep(m),Ip(m),Rp(m),NNp(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)     
    !   write(6,*) ' suma_e= S(m) , m=1',suma_e 
        S(m) = suma_e 
                          
       suma_e = E(0)+ a_0_1*F2(S(0),E(0),I(0),R(0),NN(0),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)
     1  + a_1_1* F2(Sp(m),Ep(m),Ip(m),Rp(m),NNp(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)     
       
        E(m) = suma_e                  
                  
        suma_e = I(0)+ a_0_1*F3(S(0),E(0),I(0),R(0),NN(0),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)
     1  + a_1_1* F3(Sp(m),Ep(m),Ip(m),Rp(m),NNp(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)     
       
        I(m) = suma_e
        
         suma_e = R(0)+ a_0_1*F4(S(0),E(0),I(0),R(0),NN(0),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)
     1  + a_1_1* F4(Sp(m),Ep(m),Ip(m),Rp(m),NNp(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)     
       
        R(m) = suma_e       
             NN(m) = S(m) + E(m) + I(m) + R(m)
             
 
              write(1,*)time,S(m)/1.d+6
              write(2,*)time,E(m)
              write(3,*)time,I(m)
              write(4,*)time,R(m)
              write(7,*)time,(N0-NN(m))
              write(9,*)time,alpha*I(m)              
              write(50,*)time,NN(m)/1.d+6
              Lambda = mu* NN(m) 
        
*              ntsteps1 = 2
*    Time loop 
!             

              do 1  m=in_simu1_step1+1,ntsteps1
              
            if(time.ge.t2) beta=beta2
            if(time.ge.t3) beta=beta3
            

!    PREDICTOR / EULER     

           if((m-1).gt.jmax) then
                       limit=jmax
            else
            limit=m-1
            end if
                       
             limit=m-1           
 
            
             time=m*dt
c            write( 6,*)' time step m, time ',m,time  
          
            do j=0,limit
            l=m-1-j
            b(j)=((m-l)**nu-(m-l-1)**nu)/gamma(nu+1.d0)
            end do
        
            
            suma_s=S(0)
               do j = 0,limit
               
               l=m-1-j
        !       write(6,*)' j= ',j
 !             b_j_m = ((m-l)**nu-(m-l-1)**nu)/gamma(nu+1.d0)
         !     write(6,*)'b_j_m', b_j_m
      suma_s= suma_s+dt**nu*b(j)*F1(S(l),E(l),I(l),R(l),NN(l),Lambda,
     1                      	     mu,beta,epsi,gama,alpha)
          !    write(6,*)' suma_s ',suma_s
                 enddo
         Sp(m)=suma_s
                         
           suma_s=E(0)
              do j = 0,limit
                l=m-1-j
              
 !               b_j_m = ((m-l)**nu-(m-l-1)**nu)/gamma(nu+1.d0)
      suma_s= suma_s+dt**nu*b(j)*F2(S(l),E(l),I(l),R(l),NN(l),Lambda,
     1                      	     mu,beta,epsi,gama,alpha)
                 enddo
         Ep(m)=suma_s 
         
                 suma_s=I(0)
                do j = 0,limit
               l=m-1-j
              
 !              b_j_m = ((m-l)**nu-(m-l-1)**nu)/gamma(nu+1.d0)               
                
      suma_s= suma_s+dt**nu*b(j)*F3(S(l),E(l),I(l),R(l),NN(l),Lambda,
     1                      	     mu,beta,epsi,gama,alpha)
                 enddo
         Ip(m)=suma_s
         
         suma_s= R(0)
                 do j = 0,limit
               l=m-1-j
              
  !              b_j_m = ((m-l)**nu-(m-l-1)**nu)/gamma(nu+1.d0)                   
     
      suma_s= suma_s+dt**nu*b(j)*F4(S(l),E(l),I(l),R(l),NN(l),Lambda,
     1                      	     mu,beta,epsi,gama,alpha)
                 enddo
                 
         Rp(m)=suma_s       
         
           
          NNp(m) = Sp(m) + Ep(m) + Ip(m) + Rp(m) 
          
              write(10,*)time,Sp(m)
              write(20,*)time,Ep(m)
              write(30,*)time,Ip(m)
              write(40,*)time,Rp(m)                
                                 
!    CORRECTOR/ ADAMS  for S   
       
          do j=0,limit
            l=m-j
         
         a(j)=((m-l+1)**(nu+1.)-2.d0*(m-l)**(nu+1.)+(m-l-1)**(nu+1.))
         a(j) = dt**nu *a(j)/gamma(nu+2.d0)
            end do
       
            a_0_m = ((m-1)**(nu+1.)-(m-1-nu)*m**nu)
            a_0_m = a_0_m * dt**nu/gamma(nu+2.d0)  
       
              a_m_m = dt**nu/gamma(nu+2.d0)        
        suma_e =  S(0)  + a_m_m*  
     1            F1(Sp(m),Ep(m),Ip(m),Rp(m),NNp(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha) 
        
      
                do j = 1,limit
                
                 l=m-j
 !       a_j_m=((m-l+1)**(nu+1.)-2.d0*(m-l)**(nu+1.)+(m-l-1)**(nu+1.))
 !       a_j_m = dt**nu *a_j_m/gamma(nu+2.d0)
        
        suma_e = suma_e + a(j) *F1(S(l),E(l),I(l),R(l),NNp(l),Lambda,
     1                      	     mu,beta,epsi,gama,alpha)
                  enddo
                  
    !    write(6,*) ' suma_e  for S ',suma_e 
          if(limit.eq.(m-1))then
!             a_0_m = ((m-1)**(nu+1.)-(m-1-nu)*m**nu)
 !           a_0_m = a_0_m * dt**nu/gamma(nu+2.d0)         
          suma_e = suma_e+ a_0_m*F1(S(0),E(0),I(0),R(0),NN(0),Lambda,
     1                      	     mu,beta,epsi,gama,alpha)
          end if
          
         S(m) =  suma_e 
   
   
   
!     write(6,*) ' S(m)',S(m) 

!    CORRECTOR/ ADAMS  fo E    

  !      a_m_m = dt**nu/gamma(nu+2.d0)        
        suma_e =  E(0) + a_m_m*  
     1            F2(Sp(m),Ep(m),Ip(m),Rp(m),NNp(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha) 
 
                do j = 1,limit
                l=m-j
   !     a_j_m=((m-l+1)**(nu+1.)-2.d0*(m-l)**(nu+1.)+(m-l-1)**(nu+1.))
    !    a_j_m = dt**nu *a_j_m/gamma(nu+2.d0)
        
        suma_e = suma_e + a(j)*F2(S(l),E(l),I(l),R(l),NNp(l),Lambda,
     1                      	    mu,beta,epsi,gama,alpha)
                  enddo
                  
      !  write(6,*) ' suma_e for E ',suma_e 

             if(limit.eq.(m-1))then
   !          a_0_m = ((m-1)**(nu+1.)-(m-1-nu)*m**nu)
   !         a_0_m = a_0_m * dt**nu/gamma(nu+2.d0)  
     
          suma_e = suma_e+ a_0_m*F2(S(0),E(0),I(0),R(0),NN(0),Lambda,
     1                      	     mu,beta,epsi,gama,alpha)
            end if
         
         E(m) =  suma_e 
       !   write(6,*) ' E(m)',E(m)
          
 !    CORRECTOR/ ADAMS  for I
        
 !        a_m_m = dt**nu/gamma(nu+2.d0)        
        suma_e =  I(0)  + a_m_m*  
     1            F3(Sp(m),Ep(m),Ip(m),Rp(m),NNp(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha) 
                 do j = 1,limit
                 
                 l=m-j
  !      a_j_m=((m-l+1)**(nu+1.)-2.d0*(m-l)**(nu+1.)+(m-l-1)**(nu+1.))
  !      a_j_m = dt**nu *a_j_m/gamma(nu+2.d0)
        
        suma_e = suma_e + a(j)*F3(S(l),E(l),I(l),R(l),NNp(l),Lambda,
     1                      	     mu,beta,epsi,gama,alpha)
                  enddo
                  
        !write(6,*) ' suma_e for I ',suma_e 
             if(limit.eq.(m-1))then
   !          a_0_m = ((m-1)**(nu+1.)-(m-1-nu)*m**nu)
  !          a_0_m = a_0_m * dt**nu/gamma(nu+2.d0)  
    
        suma_e = suma_e+ a_0_m*F3(S(0),E(0),I(0),R(0),NN(0),Lambda,
     1                      	     mu,beta,epsi,gama,alpha)
             end if   
    
         I(m) =  suma_e 
         ! write(6,*) ' I(m)',I(m)                 
         
         
 !    CORRECTOR/ ADAMS  for R
 

     
            suma_e =  R(0)  + a_m_m*  
     1            F4(Sp(m),Ep(m),Ip(m),Rp(m),NNp(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)

   
   
              do j = 1,limit
                 
                 l=m-j
            
        
        suma_e = suma_e + a(j)*F4(S(l),E(l),I(l),R(l),NNp(l),Lambda,
     1                      	     mu,beta,epsi,gama,alpha)
                  enddo
                  
       ! write(6,*) ' suma_e for E ',suma_e 

             if(limit.eq.(m-1))then
  !           a_0_m = ((m-1)**(nu+1.)-(m-1-nu)*m**nu)
  !          a_0_m = a_0_m * dt**nu/gamma(nu+2.d0)           
      suma_e =suma_e+ a_0_m*F4(S(0),E(0),I(0),R(0),NN(0),Lambda,
     1                      	     mu,beta,epsi,gama,alpha)     
 
            end if
 
         R(m) =  suma_e 
        !  write(6,*) ' R(m)',R(m)  
          
         NN(m) = S(m) + E(m) + I(m) + R(m)
             
              write(1,*)time,S(m)/1.d+6
              write(2,*)time,E(m)
              write(3,*)time,I(m)
              write(4,*)time,R(m)
              write(7,*)time,(N0-NN(m))
              write(9,*)time,alpha*I(m)              
              write(50,*)time,NN(m)/1.d+6
              Lambda = mu* NN(m) 
               
         
1         continue        
            write(6,*)'starts time loop for beta2',beta2     
             jmax = ntsteps2
            
            E1(0) = E(ntsteps1)
            I1(0) = I(ntsteps1)
            S1(0) = S(ntsteps1)
            R1(0) = R(ntsteps1)
            NN1(0) = NN(ntsteps1)  
            
            
            
            write(6,*)'E1(0) ',E1(0)
            write(6,*)'S1(0) ',S1(0)
            write(6,*)'I1(0) ',I1(0)
            write(6,*)'R1(0) ',R1(0)
            write(6,*)'NN1(0) ',NN1(0)
            
                 in_simu1_step1 = 1
                 
               write(6,*)' ntsteps2',ntsteps2          

                  m=1
                  
                  beta = beta2
                  
                time=m*dt
                actual_time = time + t2
                
                write(6,*)' m, time, actual_time',m,time,actual_time
                
                 b_0_1 = 1.d0/Gamma(nu+1.d0)
            
                 
      suma_s= S1(0)+dt**nu*b_0_1*F1(S1(0),E1(0),I1(0),R1(0),NN1(0),
     1        Lambda,mu,beta,epsi,gama,alpha)
        Sp1(m)=suma_s   
       
      suma_s= E1(0)+dt**nu*b_0_1*F2(S1(0),E1(0),I1(0),R1(0),NN1(0),
     1        Lambda,mu,beta,epsi,gama,alpha)
      Ep1(m)=suma_s
                  
      suma_s= I1(0)+dt**nu*b_0_1*F3(S1(0),E1(0),I1(0),R1(0),NN1(0),
     1        Lambda,mu,beta,epsi,gama,alpha)
              
      Ip1(m)=suma_s
              
      suma_s= R1(0)+dt**nu*b_0_1*F4(S1(0),E1(0),I1(0),R1(0),NN1(0),
     1        Lambda,mu,beta,epsi,gama,alpha)
              
       Rp1(m)=suma_s 
       
          NNp1(m) = Sp1(m) + Ep1(m) + Ip1(m) + Rp1(m) 
          
              write(10,*)time+t2,Sp1(m)
              write(20,*)time+t2,Ep1(m)
              write(30,*)time+t2,Ip1(m)
              write(40,*)time+t2,Rp1(m)            
       
            a_0_1 = nu* dt**nu/gamma(nu+2.d0)
            a_1_1 = dt**nu/gamma(nu+2.d0)
        !write(6,*) 'a_0_1  a_1_1',a_0_1,  a_1_1 
        
      suma_e = S1(0)+ a_0_1*F1(S1(0),E1(0),I1(0),R1(0),NN1(0),
     1          Lambda,mu,
     1                      	     beta,epsi,gama,alpha)
     1  + a_1_1* F1(Sp1(m),Ep1(m),Ip1(m),Rp1(m),NNp1(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)     
    !   write(6,*) ' suma_e= S(m) , m=1',suma_e 
        S1(m) = suma_e 
                          
       suma_e = E1(0)+ a_0_1*F2(S1(0),E1(0),I1(0),R1(0),NN1(0),
     1  Lambda,mu,
     1                      	     beta,epsi,gama,alpha)
     1  + a_1_1* F2(Sp1(m),Ep1(m),Ip1(m),Rp1(m),NNp1(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)     
       
        E1(m) = suma_e                  
                  
        suma_e = I1(0)+ a_0_1*F3(S1(0),E1(0),I1(0),R1(0),NN1(0),
     1   Lambda,mu,
     1                      	     beta,epsi,gama,alpha)
     1  + a_1_1* F3(Sp1(m),Ep1(m),Ip1(m),Rp1(m),NNp1(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)     
       
        I1(m) = suma_e
        
         suma_e = R1(0)+ a_0_1*F4(S1(0),E1(0),I1(0),R1(0),NN1(0),
     1    Lambda,mu,
     1                      	     beta,epsi,gama,alpha)
     1  + a_1_1* F4(Sp1(m),Ep1(m),Ip1(m),Rp1(m),NNp1(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)     
       
        R1(m) = suma_e       
             NN1(m) = S1(m) + E1(m) + I1(m) + R1(m)
             
 
              write(1,*)time+t2,S1(m)/1.d+6
              write(2,*)time+t2,E1(m)
              write(3,*)time+t2,I1(m)
              write(4,*)time+t2,R1(m)
              write(7,*)time+t2,(N0-NN1(m))
              write(9,*)time+t2,alpha*I1(m)              
              write(50,*)time+t2,NN1(m)/1.d+6
              Lambda = mu* NN1(m) 
            
        
*    Time loop  for beta2 
!            

              do 2  m=2,ntsteps2
            

!    PREDICTOR / EULER     

           if((m-1).gt.jmax) then
                       limit=jmax
            else
            limit=m-1
            end if
                       
             limit=m-1           
 
            
             time=m*dt
             actual_time = time + t2
             if(mod(m,100).eq.0)then
            write( 6,*)'m, time,actual_time ',m,time,actual_time  
              endif
            do j=0,limit
            l=m-1-j
            b(j)=((m-l)**nu-(m-l-1)**nu)/gamma(nu+1.d0)
            end do
        
            
            suma_s=S1(0)
               do j = 0,limit
               
               l=m-1-j
        !       write(6,*)' j= ',j
 !             b_j_m = ((m-l)**nu-(m-l-1)**nu)/gamma(nu+1.d0)
         !     write(6,*)'b_j_m', b_j_m
      suma_s= suma_s+dt**nu*b(j)*F1(S1(l),E1(l),I1(l),R1(l),NN1(l),
     1        Lambda,mu,beta,epsi,gama,alpha)
          !    write(6,*)' suma_s ',suma_s
                 enddo
         Sp1(m)=suma_s
                         
           suma_s=E1(0)
              do j = 0,limit
                l=m-1-j
              
 !               b_j_m = ((m-l)**nu-(m-l-1)**nu)/gamma(nu+1.d0)
      suma_s= suma_s+dt**nu*b(j)*F2(S1(l),E1(l),I1(l),R1(l),NN1(l),
     1        Lambda,mu,beta,epsi,gama,alpha)
                 enddo
         Ep1(m)=suma_s 
         
                 suma_s=I1(0)
                do j = 0,limit
               l=m-1-j
              
 !              b_j_m = ((m-l)**nu-(m-l-1)**nu)/gamma(nu+1.d0)               
                
      suma_s= suma_s+dt**nu*b(j)*F3(S1(l),E1(l),I1(l),R1(l),NN1(l),
     1        Lambda,mu,beta,epsi,gama,alpha)
                 enddo
         Ip1(m)=suma_s
         
         suma_s= R1(0)
                 do j = 0,limit
               l=m-1-j
              
  !              b_j_m = ((m-l)**nu-(m-l-1)**nu)/gamma(nu+1.d0)                   
     
      suma_s= suma_s+dt**nu*b(j)*F4(S1(l),E1(l),I1(l),R1(l),NN1(l),
     1        Lambda,mu,beta,epsi,gama,alpha)
                 enddo
                 
         Rp1(m)=suma_s       
         
           
          NNp1(m) = Sp1(m) + Ep1(m) + Ip1(m) + Rp1(m) 
          
              write(10,*)time+t2,Sp1(m)
              write(20,*)time+t2,Ep1(m)
              write(30,*)time+t2,Ip1(m)
              write(40,*)time+t2,Rp1(m)                
                                 
!    CORRECTOR/ ADAMS  for S   
       
          do j=0,limit
            l=m-j
         
         a(j)=((m-l+1)**(nu+1.)-2.d0*(m-l)**(nu+1.)+(m-l-1)**(nu+1.))
         a(j) = dt**nu *a(j)/gamma(nu+2.d0)
            end do
       
            a_0_m = ((m-1)**(nu+1.)-(m-1-nu)*m**nu)
            a_0_m = a_0_m * dt**nu/gamma(nu+2.d0)  
       
              a_m_m = dt**nu/gamma(nu+2.d0)        
        suma_e =  S1(0)  + a_m_m*  
     1            F1(Sp1(m),Ep1(m),Ip1(m),Rp1(m),NNp1(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha) 
        
      
                do j = 1,limit
                
                 l=m-j
 !       a_j_m=((m-l+1)**(nu+1.)-2.d0*(m-l)**(nu+1.)+(m-l-1)**(nu+1.))
 !       a_j_m = dt**nu *a_j_m/gamma(nu+2.d0)
        
        suma_e = suma_e + a(j) *F1(S1(l),E1(l),I1(l),R1(l),NNp1(l),
     1           Lambda,mu,beta,epsi,gama,alpha)
                  enddo
                  
    !    write(6,*) ' suma_e  for S ',suma_e 
          if(limit.eq.(m-1))then
!             a_0_m = ((m-1)**(nu+1.)-(m-1-nu)*m**nu)
 !           a_0_m = a_0_m * dt**nu/gamma(nu+2.d0)         
          suma_e = suma_e+ a_0_m*F1(S1(0),E1(0),I1(0),R1(0),NN1(0),
     1             Lambda,mu,beta,epsi,gama,alpha)
          end if
          
         S1(m) =  suma_e 
   
   
   
!     write(6,*) ' S(m)',S(m) 

!    CORRECTOR/ ADAMS  fo E    

  !      a_m_m = dt**nu/gamma(nu+2.d0)        
        suma_e =  E1(0) + a_m_m*  
     1            F2(Sp1(m),Ep1(m),Ip1(m),Rp1(m),NNp1(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha) 
 
                do j = 1,limit
                l=m-j
   !     a_j_m=((m-l+1)**(nu+1.)-2.d0*(m-l)**(nu+1.)+(m-l-1)**(nu+1.))
    !    a_j_m = dt**nu *a_j_m/gamma(nu+2.d0)
        
        suma_e = suma_e + a(j)*F2(S1(l),E1(l),I1(l),R1(l),NNp1(l),
     1           Lambda,mu,beta,epsi,gama,alpha)
                  enddo
                  
      !  write(6,*) ' suma_e for E ',suma_e 

             if(limit.eq.(m-1))then
   !          a_0_m = ((m-1)**(nu+1.)-(m-1-nu)*m**nu)
   !         a_0_m = a_0_m * dt**nu/gamma(nu+2.d0)  
     
          suma_e = suma_e+ a_0_m*F2(S1(0),E1(0),I1(0),R1(0),NN1(0),
     1             Lambda, mu,beta,epsi,gama,alpha)
            end if
         
         E1(m) =  suma_e 
       !   write(6,*) ' E(m)',E(m)
          
 !    CORRECTOR/ ADAMS  for I
        
 !        a_m_m = dt**nu/gamma(nu+2.d0)        
        suma_e =  I1(0)  + a_m_m*  
     1            F3(Sp1(m),Ep1(m),Ip1(m),Rp1(m),NNp1(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha) 
                 do j = 1,limit
                 
                 l=m-j
  !      a_j_m=((m-l+1)**(nu+1.)-2.d0*(m-l)**(nu+1.)+(m-l-1)**(nu+1.))
  !      a_j_m = dt**nu *a_j_m/gamma(nu+2.d0)
        
        suma_e = suma_e + a(j)*F3(S1(l),E1(l),I1(l),R1(l),NNp1(l),
     1           Lambda,mu,beta,epsi,gama,alpha)
                  enddo
                  
        !write(6,*) ' suma_e for I ',suma_e 
             if(limit.eq.(m-1))then
   !          a_0_m = ((m-1)**(nu+1.)-(m-1-nu)*m**nu)
  !          a_0_m = a_0_m * dt**nu/gamma(nu+2.d0)  
    
        suma_e = suma_e+ a_0_m*F3(S1(0),E1(0),I1(0),R1(0),NN1(0),Lambda,
     1                      	     mu,beta,epsi,gama,alpha)
             end if   
    
         I1(m) =  suma_e 
         ! write(6,*) ' I(m)',I(m)                 
         
         
 !    CORRECTOR/ ADAMS  for R
 

     
            suma_e =  R1(0)  + a_m_m*  
     1            F4(Sp1(m),Ep1(m),Ip1(m),Rp1(m),NNp1(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)

   
   
              do j = 1,limit
                 
                 l=m-j
            
        
        suma_e = suma_e + a(j)*F4(S1(l),E1(l),I1(l),R1(l),NNp1(l),
     1   Lambda,mu,beta,epsi,gama,alpha)
                  enddo
                  
       ! write(6,*) ' suma_e for E ',suma_e 

             if(limit.eq.(m-1))then
  !           a_0_m = ((m-1)**(nu+1.)-(m-1-nu)*m**nu)
  !          a_0_m = a_0_m * dt**nu/gamma(nu+2.d0)           
      suma_e =suma_e+ a_0_m*F4(S1(0),E1(0),I1(0),R1(0),NN1(0),Lambda,
     1                      	     mu,beta,epsi,gama,alpha)     
 
            end if
 
         R1(m) =  suma_e 
        !  write(6,*) ' R(m)',R(m)  
          
         NN1(m) = S1(m) + E1(m) + I1(m) + R1(m)
             
              write(1,*)time+t2,S1(m)/1.d+6
              write(2,*)time+t2,E1(m)
              write(3,*)time+t2,I1(m)
              write(4,*)time+t2,R1(m)
              write(7,*)time+t2,(N0-NN1(m))
              write(9,*)time+t2,alpha*I1(m)              
              write(50,*)time+t2,NN1(m)/1.d+6
              Lambda = mu* NN1(m) 
               
c             if(m.eq.3) stop 66
2         continue        
            write(6,*)'starts loop  for 3rd  beta= beta3',beta3     
        
              jmax = ntsteps3
        
            
            E2(0) = E1(ntsteps2)
            I2(0) = I1(ntsteps2)
            S2(0) = S1(ntsteps2)
            R2(0) = R1(ntsteps2)
            NN2(0) = NN1(ntsteps2)  

            
            write(6,*)'E2(0) ',E2(0)
            write(6,*)'S2(0) ',S2(0)
            write(6,*)'I2(0) ',I2(0)
            write(6,*)'R2(0) ',R2(0)
            write(6,*)'NN2(0) ',NN2(0)
            
            
           in_simu1_step1 = 1
                 
               write(6,*)' ntsteps3',ntsteps3          

                  m=1
                  
                  beta = beta3
                 Lambda = mu*NN2(0)
                 
                time=m*dt
                actual_time = time +  t3
                
                write(6,*)' m, time, actual_time',m,time,actual_time
                
                 b_0_1 = 1.d0/Gamma(nu+1.d0)
            
                 
      suma_s= S2(0)+dt**nu*b_0_1*F1(S2(0),E2(0),I2(0),R2(0),NN2(0),
     1        Lambda,mu,beta,epsi,gama,alpha)
        Sp2(m)=suma_s   
       
      suma_s= E2(0)+dt**nu*b_0_1*F2(S2(0),E2(0),I2(0),R2(0),NN2(0),
     1        Lambda,mu,beta,epsi,gama,alpha)
      Ep2(m)=suma_s
                  
      suma_s= I2(0)+dt**nu*b_0_1*F3(S2(0),E2(0),I2(0),R2(0),NN2(0),
     1        Lambda,mu,beta,epsi,gama,alpha)
              
      Ip2(m)=suma_s
              
      suma_s= R2(0)+dt**nu*b_0_1*F4(S2(0),E2(0),I2(0),R2(0),NN2(0),
     1        Lambda,mu,beta,epsi,gama,alpha)
              
       Rp2(m)=suma_s 
       
          NNp2(m) = Sp2(m) + Ep2(m) + Ip2(m) + Rp2(m) 
          
              write(10,*)time+t3,Sp2(m)
              write(20,*)time+t3,Ep2(m)
              write(30,*)time+t3,Ip2(m)
              write(40,*)time+t3,Rp2(m)            
       
            a_0_1 = nu* dt**nu/gamma(nu+2.d0)
            a_1_1 = dt**nu/gamma(nu+2.d0)
        !write(6,*) 'a_0_1  a_1_1',a_0_1,  a_1_1 
        
      suma_e = S2(0)+ a_0_1*F1(S2(0),E2(0),I2(0),R2(0),NN2(0),
     1          Lambda,mu,
     1                      	     beta,epsi,gama,alpha)
     1  + a_1_1* F1(Sp2(m),Ep2(m),Ip2(m),Rp2(m),NNp2(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)     
    !   write(6,*) ' suma_e= S(m) , m=1',suma_e 
        S2(m) = suma_e 
                          
       suma_e = E2(0)+ a_0_1*F2(S2(0),E2(0),I2(0),R2(0),NN2(0),
     1  Lambda,mu,
     1                      	     beta,epsi,gama,alpha)
     1  + a_1_1* F2(Sp2(m),Ep2(m),Ip2(m),Rp2(m),NNp2(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)     
       
        E2(m) = suma_e                  
                  
        suma_e = I2(0)+ a_0_1*F3(S2(0),E2(0),I2(0),R2(0),NN2(0),
     1   Lambda,mu,
     1                      	     beta,epsi,gama,alpha)
     1  + a_1_1* F3(Sp2(m),Ep2(m),Ip2(m),Rp2(m),NNp2(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)     
       
        I2(m) = suma_e
        
         suma_e = R2(0)+ a_0_1*F4(S2(0),E2(0),I2(0),R2(0),NN2(0),
     1    Lambda,mu,
     1                      	     beta,epsi,gama,alpha)
     1  + a_1_1* F4(Sp2(m),Ep2(m),Ip2(m),Rp2(m),NNp2(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)     
       
        R2(m) = suma_e       
             NN2(m) = S2(m) + E2(m) + I2(m) + R2(m)
             
 
              write(1,*)time+t3,S2(m)/1.d+6
              write(2,*)time+t3,E2(m)
              write(3,*)time+t3,I2(m)
              write(4,*)time+t3,R2(m)
              write(7,*)time+t3,(N0-NN2(m))
              write(9,*)time+t3,alpha*I2(m)              
              write(50,*)time+t3,NN2(m)/1.d+6
              Lambda = mu* NN2(m) 
        
                
*    Time loop  for beta2 
!            

              do 3  m=2,ntsteps3
            

!    PREDICTOR / EULER     

           if((m-1).gt.jmax) then
                       limit=jmax
            else
            limit=m-1
            end if
                       
             limit=m-1           
 
            
             time=m*dt
             actual_time = time + t2
             if(mod(m,2000).eq.0)then
            write( 6,*)'m, time,actual_time ',m,time,actual_time  
              endif
            do j=0,limit
            l=m-1-j
            b(j)=((m-l)**nu-(m-l-1)**nu)/gamma(nu+1.d0)
            end do
        
            
            suma_s=S2(0)
               do j = 0,limit
               
               l=m-1-j
        !       write(6,*)' j= ',j
 !             b_j_m = ((m-l)**nu-(m-l-1)**nu)/gamma(nu+1.d0)
         !     write(6,*)'b_j_m', b_j_m
      suma_s= suma_s+dt**nu*b(j)*F1(S2(l),E2(l),I2(l),R2(l),NN2(l),
     1        Lambda,mu,beta,epsi,gama,alpha)
          !    write(6,*)' suma_s ',suma_s
                 enddo
         Sp2(m)=suma_s
                         
           suma_s=E2(0)
              do j = 0,limit
                l=m-1-j
              
 !               b_j_m = ((m-l)**nu-(m-l-1)**nu)/gamma(nu+1.d0)
      suma_s= suma_s+dt**nu*b(j)*F2(S2(l),E2(l),I2(l),R2(l),NN2(l),
     1        Lambda,mu,beta,epsi,gama,alpha)
                 enddo
         Ep2(m)=suma_s 
         
                 suma_s=I2(0)
                do j = 0,limit
               l=m-1-j
              
 !              b_j_m = ((m-l)**nu-(m-l-1)**nu)/gamma(nu+1.d0)               
                
      suma_s= suma_s+dt**nu*b(j)*F3(S2(l),E2(l),I2(l),R2(l),NN2(l),
     1        Lambda,mu,beta,epsi,gama,alpha)
                 enddo
         Ip2(m)=suma_s
         
         suma_s= R2(0)
                 do j = 0,limit
               l=m-1-j
              
  !              b_j_m = ((m-l)**nu-(m-l-1)**nu)/gamma(nu+1.d0)                   
     
      suma_s= suma_s+dt**nu*b(j)*F4(S2(l),E2(l),I2(l),R2(l),NN2(l),
     1        Lambda,mu,beta,epsi,gama,alpha)
                 enddo
                 
         Rp2(m)=suma_s       
         
           
          NNp2(m) = Sp2(m) + Ep2(m) + Ip2(m) + Rp2(m) 
          
              write(10,*)time+t3,Sp2(m)
              write(20,*)time+t3,Ep2(m)
              write(30,*)time+t3,Ip2(m)
              write(40,*)time+t3,Rp2(m)                
                                 
!    CORRECTOR/ ADAMS  for S   
       
          do j=0,limit
            l=m-j
         
         a(j)=((m-l+1)**(nu+1.)-2.d0*(m-l)**(nu+1.)+(m-l-1)**(nu+1.))
         a(j) = dt**nu *a(j)/gamma(nu+2.d0)
            end do
       
            a_0_m = ((m-1)**(nu+1.)-(m-1-nu)*m**nu)
            a_0_m = a_0_m * dt**nu/gamma(nu+2.d0)  
       
              a_m_m = dt**nu/gamma(nu+2.d0)        
        suma_e =  S2(0)  + a_m_m*  
     1            F1(Sp2(m),Ep2(m),Ip2(m),Rp2(m),NNp2(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha) 
        
      
                do j = 1,limit
                
                 l=m-j
 !       a_j_m=((m-l+1)**(nu+1.)-2.d0*(m-l)**(nu+1.)+(m-l-1)**(nu+1.))
 !       a_j_m = dt**nu *a_j_m/gamma(nu+2.d0)
        
        suma_e = suma_e + a(j) *F1(S2(l),E2(l),I2(l),R2(l),NNp2(l),
     1           Lambda,mu,beta,epsi,gama,alpha)
                  enddo
                  
    !    write(6,*) ' suma_e  for S ',suma_e 
          if(limit.eq.(m-1))then
!             a_0_m = ((m-1)**(nu+1.)-(m-1-nu)*m**nu)
 !           a_0_m = a_0_m * dt**nu/gamma(nu+2.d0)         
          suma_e = suma_e+ a_0_m*F1(S2(0),E2(0),I2(0),R2(0),NN2(0),
     1             Lambda,mu,beta,epsi,gama,alpha)
          end if
          
         S2(m) =  suma_e 
   
   
   
!     write(6,*) ' S(m)',S(m) 

!    CORRECTOR/ ADAMS  fo E    

  !      a_m_m = dt**nu/gamma(nu+2.d0)        
        suma_e =  E2(0) + a_m_m*  
     1            F2(Sp2(m),Ep2(m),Ip2(m),Rp2(m),NNp2(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha) 
 
                do j = 1,limit
                l=m-j
   !     a_j_m=((m-l+1)**(nu+1.)-2.d0*(m-l)**(nu+1.)+(m-l-1)**(nu+1.))
    !    a_j_m = dt**nu *a_j_m/gamma(nu+2.d0)
        
        suma_e = suma_e + a(j)*F2(S2(l),E2(l),I2(l),R2(l),NNp2(l),
     1           Lambda,mu,beta,epsi,gama,alpha)
                  enddo
                  
      !  write(6,*) ' suma_e for E ',suma_e 

             if(limit.eq.(m-1))then
   !          a_0_m = ((m-1)**(nu+1.)-(m-1-nu)*m**nu)
   !         a_0_m = a_0_m * dt**nu/gamma(nu+2.d0)  
     
          suma_e = suma_e+ a_0_m*F2(S2(0),E2(0),I2(0),R2(0),NN2(0),
     1             Lambda, mu,beta,epsi,gama,alpha)
            end if
         
         E2(m) =  suma_e 
       !   write(6,*) ' E(m)',E(m)
          
 !    CORRECTOR/ ADAMS  for I
        
 !        a_m_m = dt**nu/gamma(nu+2.d0)        
        suma_e =  I2(0)  + a_m_m*  
     1            F3(Sp2(m),Ep2(m),Ip2(m),Rp2(m),NNp2(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha) 
                 do j = 1,limit
                 
                 l=m-j
  !      a_j_m=((m-l+1)**(nu+1.)-2.d0*(m-l)**(nu+1.)+(m-l-1)**(nu+1.))
  !      a_j_m = dt**nu *a_j_m/gamma(nu+2.d0)
        
        suma_e = suma_e + a(j)*F3(S2(l),E2(l),I2(l),R2(l),NNp2(l),
     1           Lambda,mu,beta,epsi,gama,alpha)
                  enddo
                  
        !write(6,*) ' suma_e for I ',suma_e 
             if(limit.eq.(m-1))then
   !          a_0_m = ((m-1)**(nu+1.)-(m-1-nu)*m**nu)
  !          a_0_m = a_0_m * dt**nu/gamma(nu+2.d0)  
    
        suma_e = suma_e+ a_0_m*F3(S2(0),E2(0),I2(0),R2(0),NN2(0),Lambda,
     1                      	     mu,beta,epsi,gama,alpha)
             end if   
    
         I2(m) =  suma_e 
         ! write(6,*) ' I(m)',I(m)                 
         
         
 !    CORRECTOR/ ADAMS  for R
      
            suma_e =  R2(0)  + a_m_m*  
     1            F4(Sp2(m),Ep2(m),Ip2(m),Rp2(m),NNp2(m),Lambda,mu,
     1                      	     beta,epsi,gama,alpha)

              do j = 1,limit
                 
                 l=m-j
            
        
        suma_e = suma_e + a(j)*F4(S2(l),E2(l),I2(l),R2(l),NNp2(l),
     1   Lambda,mu,beta,epsi,gama,alpha)
                  enddo
                  
       ! write(6,*) ' suma_e for E ',suma_e 

             if(limit.eq.(m-1))then
  !           a_0_m = ((m-1)**(nu+1.)-(m-1-nu)*m**nu)
  !          a_0_m = a_0_m * dt**nu/gamma(nu+2.d0)           
      suma_e =suma_e+ a_0_m*F4(S2(0),E2(0),I2(0),R2(0),NN2(0),Lambda,
     1                      	     mu,beta,epsi,gama,alpha)     
 
            end if
 
         R2(m) =  suma_e 
        !  write(6,*) ' R(m)',R(m)  
          
         NN2(m) = S2(m) + E2(m) + I2(m) + R2(m)
             
              write(1,*)time+t3,S2(m)/1.d+6
              write(2,*)time+t3,E2(m)
              write(3,*)time+t3,I2(m)
              write(4,*)time+t3,R2(m)
              write(7,*)time+t3,(N0-NN2(m))
              write(9,*)time+t3,alpha*I2(m)              
              write(50,*)time+t3,NN2(m)/1.d+6
              Lambda = mu* NN2(m)
        
3             continue
            
              stop
               end
               
               
               
             
       
	  double precision function F1(S,E,I,R,N,Lambda,mu,
     1                      	  beta,epsi,gama,alpha)
       implicit none
	    real*8 S,E,I,R,N
	    real*8 Lambda,mu,beta,epsi,gama,alpha
	    
        F1 = Lambda - mu * S - beta*S*I/N
        return
        end

	  double precision function F2(S,E,I,R,N,Lambda,mu,
     1                      	  beta,epsi,gama,alpha)
       implicit none
	    real*8 S,E,I,R,N
	    real*8 Lambda,mu,beta,epsi,gama,alpha
	    
        F2 = beta*S*I/N -(mu+epsi)*E
        return
        end
        
        
	    double precision function F3(S,E,I,R,N,Lambda,mu,
     1                      	  beta,epsi,gama,alpha)
        implicit none
	    real*8 t,S,E,I,R,N
	    real*8 Lambda,mu,beta,epsi,gama,alpha
	    
        F3 = epsi*E - (gama+mu+alpha)*I
        return        
        end
        
        double precision function F4(S,E,I,R,N,Lambda,mu,
     1                      	  beta,epsi,gama,alpha)
        implicit none
	    real*8 t,S,E,I,R,N
	    real*8 Lambda,mu,beta,epsi,gama,alpha
	    
        F4 =  gama*I - mu*R
        return
         end            
