            implicit none
            integer N,nt,nfin,N0,j,ntsteps1,in_simu1_step,k
            integer ntsteps2,in_simu2_step,ntsteps3,in_simu3_step
            integer ntsteps4
            real*8 alpha, beta, gamma,Lambda,mu,dt,IFR
            real*8 beta2,time,beta1, beta3
c-----
            real*8 epsi,sim_time1,xfin1,xin1
             real*8 sim_time2,sim_time3,xfin2,xfin3,xin2,xin3,xin4,xfin4
            real*8 t1,t2,t3,t4,t5
            real*8 sim_time4
            real*8 dE
            real*8 dS
            real*8 dI
            real*8 dR
            real*8 S(0:1000000), E(0:1000000), I(0:1000000)
            real*8 R(0:1000000), Dt_t(0:1000000)
            real*8 R0,NN
            open(unit=1,file='susceptible.n')
             open(unit=2,file='exposed.n')
              open(unit=3,file='infected.n')
              open(unit=4,file='recovered.n')
c write deaths and deaths per day in this file
              open(unit=7,file='dead_individuals.n')
               open(unit=9,file='dead_individuals_per_day.n')
                    open(unit=10,file='NN.n')  
          !   initial data
          
             write(6,*)'NN_dead_ind_N0-NN.n is dead individuals'
          
            dt = 0.01d0
c MOD: AHORA NO HACE FALTA PONER UN DIA MENOS            
            t2 = 31.d0
            t3 = 70.d0
            t4 =  600.d0
c ----
            sim_time1 = t4
c ------
            
            xfin1 = sim_time1/dt
            
c MOD: ESTO VENIA DE t1            
            in_simu1_step = 1
            
            ntsteps1 = xfin1
            
            
            write(6,*)'simulation time1 (days) ',sim_time1
            write(6,*)'in_simu1_step           ',in_simu1_step
            write(6,*)' number of time steps 1 ', ntsteps1  
            write(6,*)'time step  (days)       ',dt
        
        
            N0 = 14839026.d0
            
            write(6,*)'N0 ',N0
            
            E(0) = 162.d0
            I(0) = 100.d0
c MOD: ACA FALTABA RESTAR I(0)
            S(0) = N0 - E(0) - I(0) 
            R(0) = 0.d0
c
            write(6,*)'E(0) ',E(0)
            write(6,*)'S(0) ',S(0)
             write(6,*)'I(0) ',I(0)
             write(6,*)'R(0) ',R(0)
            
             NN =  N0
             mu = 1.d0/76.d0/365.d0
            
             Lambda = mu* N0
             alpha = 0.00285d0 
             beta = 0.5d0
             beta = 0.50478d0
             beta1 = beta
             beta2 = 0.14343d0
        !     beta3 = 0.37  fit 11 mayo
            
             beta3 = 0.24   !fit 21 mayo
          !   beta3 = 0.31
             beta3 = 0.234 
             epsi = 11.06d0
             epsi = 11.064d0
             epsi = 1.d0/epsi
             gamma= 6.7420d0
             gamma= 6.740d0 
             
             gamma= 1.d0/gamma
            
        !     beta2 = 0.1343d0
         
             
c --------       
            R0 = beta/(gamma+ alpha)
            IFR = 100.d0*alpha/gamma
            
            write(6,*)'parameters for time interval t1, t2 :', t1,t2
            
            write(6,*)'*********************** '
            write(6,*)
         
            write(6,*)'Lambda                  ',Lambda
            write(6,*)'mu                      ',mu
            write(6,*)'alpha                   ',alpha
            write(6,*)'beta1                   ',beta
            write(6,*)'beta2                   ',beta2
            write(6,*)'beta3                   ',beta3
            write(6,*)'epsi^{-1}               ',1/epsi
            write(6,*)'gamma^{-1}              ',1/gamma
            write(6,*)'R0 = beta1/(gamma+alpha) ',R0
            write(6,*)'IFR                     ',IFR
            write(6,*)
            write(6,*)'*********************** '
             R0 = beta2/(gamma+ alpha)
                write(6,*)'R02 = beta2/(gamma+alpha) ',R0
             R0 = beta3/(gamma+ alpha)
                write(6,*)'R03 = beta3/(gamma+alpha) ',R0   
                
            write(6,*)'*****************************'
            write(6,*)'S(0) ',S(0)
            write(6,*)'E(0) ',E(0)
            write(6,*)'I(0) ',I(0)
            write(6,*)'R(0) ',R(0)
           
            write(6,*)'NN   ',NN
            
              write(6,*)'*****************************'
            do j=in_simu1_step-1,ntsteps1
            
            
            
            time=(j+1)*dt
            if(time.ge.t2) beta=beta2
            if(time.ge.t3) beta=beta3
c -----
             S(j+1) = S(j) + dt*(Lambda - mu*S(j)
     1                     - beta*S(j)*I(j)/NN)
      E(j+1) = E(j) + dt*( beta*S(j)*I(j)/NN-(mu+epsi)*E(j) ) 
            I(j+1) = I(j) + dt*(epsi*E(j) - (gamma+mu+alpha)*I(j))
            R(j+1) = R(j) + dt*(gamma*I(j) - mu*R(j))
            NN = S(j+1) + E(j+1) + I(j+1) + R(j+1)
c --------
            if (j.eq.0)then
         
            
            write(6,*)'*****************************'
            write(6,*)'S(1) ',S(1)
            write(6,*)'E(1) ',E(1)
            write(6,*)'I(1) ',I(1)
            write(6,*)'R(1) ',R(1)
            write(6,*)'NN(1)',NN
             write(6,*)'*****************************'
            
            endif
            
            if (j.eq.1)then
            
             write(6,*)'*****************************'
             write(6,*)'S(2) ',S(2)
             write(6,*)'E(2) ',E(2)
             write(6,*)'I(2) ',I(2)
             write(6,*)'R(2) ',R(2)
             write(6,*)'NN(2) ',NN
            
             write(6,*)'*****************************'
            endif
                

            write(1,*)(j+1)*dt,S(j+1)/1.d6
            write(2,*)(j+1)*dt,E(j+1)
             write(3,*)(j+1)*dt,I(j+1)
               write(4,*)(j+1)*dt,R(j+1)
C MOD: AHORA ESCRIBO TODO EN ESTE FILE
c deaths and deaths per day
                 write(7,*)time,(N0-NN)
                 
                  write(9,*)time,alpha*I(j) 
                  write(10,*)time,NN
             Lambda = mu* NN
            
            enddo
                do j=1,ntsteps1
             !   dS = (S(j+1)-S(j))/dt
             !    dE = (E(j+1)-E(j))/dt
             !     dI = (I(j+1)-I(j))/dt 
             !      dR = (R(j+1)-R(j))/dt
             !      
             !    Dt_t(j) = -( dS + dE + dI + dR)
             !   write(8,*)j*dt,(Dt_t(j))
             !   write(9,*)j*dt,alpha*I(j)
                enddo
        
                write(6,*)' E(ntsteps1)',E(ntsteps1) 
                write(6,*)' I(ntsteps1)',I(ntsteps1)
                write(6,*)' S(ntsteps1)',S(ntsteps1)
                write(6,*)' R(ntsteps1)',R(ntsteps1)
                write(6,*)' N0 - E(ntsteps1) - 1  ', 
     1          N0 - E(ntsteps1) - 1 
                R0 = beta/(gamma+ alpha)

c 
              stop
               end
            
